﻿using System;

namespace CellularAutomata.RuleSets
{
    public class Gliders : RuleSet
    {
        public Gliders(int[,] field, int maxX, int maxY)
            : base(field, maxX, maxY)
        {
        }

        protected override int[,] TickAlgorithm()
        {
            int[,] field2 = new int[_maxX, _maxY];

            // /2 - gliders
            // The first number(s) is what is required for a cell to continue.
            // The second number(s) is the requirement for birth.
            for (int y = 0; y < _maxY; y++)
            {
                for (int x = 0; x < _maxX; x++)
                {
                    int neighbors = GetNumberOfNeighbors(x, y);
                    if (neighbors == 2)
                    {
                        // cell is born.
                        field2[x, y] = 1;
                        continue;
                    }

                    // cell dies.
                    field2[x, y] = 0;
                }
            }

            return field2;
        }
    }
}
